package handler

import (
	"fusenapi/utils/auth"
	"net/http"

	"fusenapi/product/internal/logic"
	"fusenapi/product/internal/svc"
	"fusenapi/product/internal/types"
	"github.com/zeromicro/go-zero/rest/httpx"
)

func GetProductInfoHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		//检测登录权限
		userInfo := auth.CheckAuth(r)
		var req types.GetProductInfoReq
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := logic.NewGetProductInfoLogic(r.Context(), svcCtx)
		resp, err := l.GetProductInfo(&req, userInfo)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
