package handler

import (
	"fusenapi/utils/auth"
	"net/http"

	"fusenapi/product/internal/logic"
	"fusenapi/product/internal/svc"
	"fusenapi/product/internal/types"
	"github.com/zeromicro/go-zero/rest/httpx"
)

func GetProductListHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		//检测登录权限
		userInfo := auth.CheckAuth(r)
		var req types.GetProductListReq
		if err := httpx.Parse(r, &req); err != nil {
			httpx.OkJsonCtx(r.Context(), w, types.Response{Code: 500, Message: err.Error()})
			return
		}
		l := logic.NewGetProductListLogic(r.Context(), svcCtx)
		resp, err := l.GetProductList(&req, userInfo)
		if err != nil {
			httpx.OkJsonCtx(r.Context(), w, types.Response{Code: 500, Message: err.Error()})
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
